
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ConversationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.create(
            {
                id: data.id || undefined,
        
        conversation_type: data.conversation_type
        ||
        null
            ,
            
        title_text: data.title_text
        ||
        null
            ,
            
        last_message_at: data.last_message_at
        ||
        null
            ,
            
        is_archived: data.is_archived
        ||
        false
        
            ,
            
        is_muted: data.is_muted
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await conversations.setGroup( data.group || null, {
            transaction,
        });
        

        
        await conversations.setParticipants(data.participants || [], {
            transaction,
        });
        

        

        return conversations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const conversationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                conversation_type: item.conversation_type
            ||
            null
            ,
            
                title_text: item.title_text
            ||
            null
            ,
            
                last_message_at: item.last_message_at
            ||
            null
            ,
            
                is_archived: item.is_archived
            ||
            false
        
            ,
            
                is_muted: item.is_muted
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const conversations = await db.conversations.bulkCreate(conversationsData, { transaction });

        // For each item created, replace relation files
        

        return conversations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const conversations = await db.conversations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.conversation_type !== undefined) updatePayload.conversation_type = data.conversation_type;
        
        
        if (data.title_text !== undefined) updatePayload.title_text = data.title_text;
        
        
        if (data.last_message_at !== undefined) updatePayload.last_message_at = data.last_message_at;
        
        
        if (data.is_archived !== undefined) updatePayload.is_archived = data.is_archived;
        
        
        if (data.is_muted !== undefined) updatePayload.is_muted = data.is_muted;
        
        
        updatePayload.updatedById = currentUser.id;

        await conversations.update(updatePayload, {transaction});

        
        
        if (data.group !== undefined) {
            await conversations.setGroup(
              
              data.group,
              
              { transaction }
            );
        }
        

        
        
        if (data.participants !== undefined) {
            await conversations.setParticipants(data.participants, { transaction });
        }
        

        

        return conversations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of conversations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of conversations) {
                await record.destroy({transaction});
            }
        });


        return conversations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findByPk(id, options);

        await conversations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await conversations.destroy({
            transaction
        });

        return conversations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findOne(
            { where },
            { transaction },
        );

        if (!conversations) {
            return conversations;
        }

        const output = conversations.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.messages_conversation = await conversations.getMessages_conversation({
            transaction
        });
        
        
        
        
        
        output.notifications_conversation = await conversations.getNotifications_conversation({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.participants = await conversations.getParticipants({
            transaction
        });
        
        
        output.group = await conversations.getGroup({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.groups,
        as: 'group',
        
        where: filter.group ? {
          [Op.or]: [
            { id: { [Op.in]: filter.group.split('|').map(term => Utils.uuid(term)) } },
            {
              name_text: {
                [Op.or]: filter.group.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },


      {
        model: db.users,
        as: 'participants',
        required: false,
      },


    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'conversations',
                        'title_text',
                        filter.title_text,
                    ),
                };
            }
            

            
            

            
            if (filter.last_message_atRange) {
                const [start, end] = filter.last_message_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.conversation_type) {
                where = {
                    ...where,
                conversation_type: filter.conversation_type,
            };
            }
            
            if (filter.is_archived) {
                where = {
                    ...where,
                is_archived: filter.is_archived,
            };
            }
            
            if (filter.is_muted) {
                where = {
                    ...where,
                is_muted: filter.is_muted,
            };
            }
            


      


      if (filter.participants) {
        const searchTerms = filter.participants.split('|');

        include = [
          {
            model: db.users,
            as: 'participants_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  firstName: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.conversations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'conversations',
                        'title_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.conversations.findAll({
            attributes: [ 'id', 'title_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title_text,
        }));
    }

    
};

